/* file qspart.c */
/*#define CCPVM
*/
/*
#define CCPVM
*/
#define CCMPI
 

#ifdef CCPVM
#define BARRIER pvm_barrier("PVM_COMM_WORLD",NUMPROCESSORS)
#define GROUP	pvm_joingroup("PVM_COMM_WORLD")
#else
#define BARRIER MPI_Barrier(MPI_COMM_WORLD)
#define GROUP	
#endif

#include <sys/time.h>
#include "../llcsync.h"
#include "../llcprnt.h"
#include "../llcreduc.h"
#include "headers.h"
#include "support.c"
#include <mytime.h>

#define MAX_TIMES 10
#define MAX_DEEP   20
#define MAX_REP	1 



/******* chronos	 */

CLOCKTYPE Timediv1,Timevid2,FinalTime,InitialTime,TimeS1,TimeS2,TimeP1,TimeP2;
CLOCKTYPE com_time1,com_time2;

double t_fst[MAX_TIMES]; /* only one division M-step in BSPWB */
double t_division[MAX_TIMES][MAX_DEEP];   /* there are as many as recursion depth */
double t_combination[MAX_TIMES][MAX_DEEP]; /* there are as many as recursion depth */
double t_sequential[MAX_TIMES];
double t_comm[MAX_TIMES][MAX_DEEP];
int sizeenv[MAX_TIMES][MAX_DEEP], sizerec[MAX_TIMES][MAX_DEEP];



/******* variables globales	 */

int REP;
int deep = 0;
int deep1 =0;
int deep2 =0;

/******* macros 	*/


#define PARHP(f1, v1, s1, f2, v2, s2)							\
{											\
  bit--;										\
  NUMPROCESSORS >>= 1;									\
  if ((LLNAME & (1 << bit)) == 0) {							\
     f1;										\
		 \
		 BARRIER;\
		 \
		 GETTIME(com_time1); \
     MPI_Sendrecv(&s1, 1, MPI_INT, LLPARTNER(bit), LLCTAG, 				\
                  &s2, 1, MPI_INT, LLPARTNER(bit), LLCTAG, LLC_COMM, &status);	        \
     MPI_Sendrecv(v1, s1, MPI_CHAR, LLPARTNER(bit), LLCTAG, 				\
                  v2, s2, MPI_CHAR, LLPARTNER(bit), LLCTAG, LLC_COMM, &status);	        \
		 GETTIME(com_time2);\
		 \
		 BARRIER;\
		 \
		 GPRINTF("f1--NAME: %d deep= %d  env(s1)= %d rec(s2)= %d \n",LLNAME, deep2, s1,s2);\
		 DIFTIME(com_time2,com_time1,t_comm[REP][deep2]);\
	         sizeenv[REP][deep2]=s1;sizerec[REP][deep2++]=s2;\
  }											\
  else {										\
     f2;										\
		 \
		 BARRIER;\
		 \
		 GETTIME(com_time1);\
     MPI_Sendrecv(&s2, 1, MPI_INT, LLPARTNER(bit), LLCTAG, 				\
                  &s1, 1, MPI_INT, LLPARTNER(bit), LLCTAG, LLC_COMM, &status);	        \
     MPI_Sendrecv(v2, s2, MPI_CHAR, LLPARTNER(bit), LLCTAG, 				\
                  v1, s1, MPI_CHAR, LLPARTNER(bit), LLCTAG, LLC_COMM, &status);	        \
		 GETTIME(com_time2);\
		 \
		 BARRIER;\
		 \
		  GPRINTF("f2--NAME: %d  deep= %d  env(s2)= %d rec(s1)= %d \n",LLNAME, deep2, s2,s1);\
 	          DIFTIME(com_time2,com_time1,t_comm[REP][deep2]);\
 		 sizeenv[REP][deep2]=s2;sizerec[REP][deep2++]=s1;\
  }                                                                                     \
  bit++;				                                               	\
  NUMPROCESSORS <<= 1;                                                                  \
}

int array[SIZE];


/**************************************************************************/
/*				MAIN					  */
/**************************************************************************/

int main(int argc, char * argv[]) {

  int name,d; 
  int first, last;                      /* Range to sort in the array */
  int seed;
  int num_elems;
  double t_seq[MAX_TIMES], t_par[MAX_TIMES];
  /* double t_dif[MAX_TIMES];*/

  GETTIME(InitialTime); 


  INITIALIZE(argc, argv);

  for (REP = 0; REP < MAX_REP; REP++) {
    seed = 7;
     
 

  initialize(array, seed);
   BARRIER;

    /*** SEQUENTIAL ********************************************************/
    /*GPRINTF("%d: Sorting sequentially %d elements\n",NAME,SIZE);*/
    REDUCEBYADD (num_elems, 1);  /* synchronization */
    GETTIME(TimeS1); 
    last = SIZE - 1;
    quicksortseq(array, 0, last);
    GETTIME(TimeS2); 
    DIFTIME(TimeS2,TimeS1,t_seq[REP]);
    /*GPRINTF("%d: FIN:Sorting sequentially %d elements\n",NAME,SIZE);*/
    initialize(array, seed);


    /*** PARALLEL  **********************************************************/
   BARRIER;
   /*GPRINTF("%d: 1-Sorting in parallel %d elements\n",NAME,SIZE);*/
   REDUCEBYADD (num_elems, 1);  /* synchronization */
   
    GETTIME(TimeP1);  
    first = 0; deep=0;deep1=0;
    last = SIZE - 1;

    qs(array, first, last);
/*write_array(array);*/
    GETTIME(TimeP2); 
    DIFTIME(TimeP2,TimeP1,t_par[REP]);
   /* GPRINTF("%d: 1-Sorting in parallel %d elements\n",NAME,SIZE);*/

  }  /* BUCLE REP */
  
 BARRIER;
  
 /*** REPORTE DE TIEMPOS  **************************************************/
  	if (NAME == 0) { 
	PRINTF("PARALLEL QSORT WRITTEN IN MPI-llc. ARGENTINA. RECURSIVE COMMON-COMMON VERSION     \n");
	PRINTF("SEQUENTIAL     \tREP            \tNAME           \tDEEP           \tSIZE           \tENDSEQ (P=1)      \tPAR            \tNUMPROC        \tSPEEDUP        \tDIVISION       \tCOMBIN         \tFIRST.ST.      \tCOMMUNICAT	\tSIZE-ENV	\tSIZE-REC	\n");
	}
  
  
 /*SIZE =  16; */
   
  for(REP = 0; REP < 2; REP++)  {
    for (name = 0; name <  NUMPROCESSORS; name++) {
               	 if (NAME == name) {
			 for (d=0; d<deep; d++) {
					printf("%8.8lf     \t",t_seq[REP]);
					printf("%8d    \t%8d     \t%8d     \t%8d     \t",REP, NAME, d, SIZE);
				 printf("%8.8lf     \t%8.8lf     \t", t_sequential[REP], t_par[REP]);
				 printf("%8d     \t",NUMPROCESSORS);
				 if  (t_par[REP] != (double) 0.0) printf("%8.8lf     \t", (double)(t_seq[REP]/t_par[REP]));
				 else printf("warning!!!!!!     \n");
				 printf("%8.8lf     \t%8.8lf     \t", t_division[REP][d], t_combination[REP][d]);
				 printf("%8.8lf      \t", t_fst[REP]);
				 printf("%8.8lf	\t", t_comm[REP][d]);
 				printf("%d	\t", sizeenv[REP][d]);
 				printf("%d\t", sizerec[REP][d]);

				 printf("     \n");
			 } /* for */
		 } /* if */
		   
		 fflush(stdout);
		 BARRIER;
    } /* for */
		 		 
		/* SIZE = 2*SIZE;*/
		 BARRIER;
  }

	 fflush(stdout); 
	 BARRIER;

  EXIT;
}
 /* main*/

/****************************************************************************/
/*  				PARALLEL QSORT		    	       	    */
/****************************************************************************/

void qs(int *v, int first, int last) {
  int middle,size;
 
CLOCKTYPE Timediv1, Timediv2, seqTime1, seqTime2;
/*CLOCKTYPE combinationTime1,  combinationTime2;*/
    if (NUMPROCESSORS > 1) {
    
    	GETTIME(Timediv1);
    	if (first < last) {
      		middle = (first + last) / 2;
     	 	size = (middle - first + 1) * sizeof(int);
      		find(v, first, last, middle);
		GETTIME(Timediv2);   
       		DIFTIME(Timediv2,Timediv1,t_division[REP][deep]);deep++;
		      		
	PARHP(qs(v, first, middle),v+first,(size), qs(v, middle + 1, last), (v + middle + 1), (size));

       }
  } /* fin NUMPROC */
  else
	{
        GETTIME(seqTime1);
        quicksortseq(v, first, last);
	GETTIME(seqTime2); /* this is also the clock for division time */
	DIFTIME(seqTime2,seqTime1,t_sequential[REP]);
	DIFTIME(seqTime2,TimeP1,t_fst[REP]);
	}

}
