#define K (1024)
#define M (1024 * 1024)
#define SIZE  (5*M)

#define MAX_REP 1
float SEQ[MAX_REP];		/* Sequential time */
float par_t[MAX_REP];		/* Parallel time */
float SPEED[MAX_REP]; 		/* Speedup */

/* Sets randomly the values for the array */
void initialize(int *v, int seed) {
  unsigned i;

   /*GPRINTF("Seed: %d\n", seed);*/
   srandom(seed);
   for(i = 0; i < SIZE; i++)
     v[i] = (int)random();
}
/****************************************************************************/
/* Escribe el array */
void write_array(int *v) {
  unsigned i;

  for(i = 0; i < SIZE; i++)
    GPRINTF("NAME: %d v[%u] = %i\n", NAME, i, v[i]);
}
/****************************************************************************/
void test(int *v) {
  int i;
  BOOLEAN error;

  error = FALSE;
  for (i = 0; i < SIZE - 1; i++)
    if (v[i] > v[i + 1]) error = TRUE;

  if (error)
    GPRINTF("ERROR: Processor %d: Not sorted.\n", NAME);
    /* GPRINTF("ERROR: Processor %d: Not sorted. Elements %d and %d. (%d, %d)\n", NAME, i, i+1, v[i], v[i+1]); */
  else
    GPRINTF("%d: Array sorted. first: %d last: %d\n", NAME, v[0], v[SIZE-1]);
}
/****************************************************************************/
/* Quicksortcclasico (Wirth) */
void quicksortseq(int *v, int first, int last) {
  int i, j, pivot, temp;
	double aux;

  i = first;
  j = last;
	aux = 1.0 * (double)v[first] + (double)v[last] + (double)v[(first + last) / 2];
	pivot = (int)(aux / 3.0);
  /* pivot = (v[first] + v[last] + v[(first + last) / 2]) / 3; */
  do {
    while (v[i] < pivot)
      i++;
    while (pivot < v[j])
      j--;
    if (i <= j) {
      temp = v[i];    /* intercambiar v[i] y v[j] */
      v[i] = v[j];
      v[j] = temp;
      i++;
      j--;
     }
   } while (i <= j);
   if (first < j)
     quicksortseq(v, first, j);
   if (i < last)
     quicksortseq(v, i, last);
}
/****************************************************************************/
/* Partition clsico (el de Hoare) */
void partition(int *v, int *i, int *j, int first, int last) {
	int pivot, temp;
	double aux;

	*i = first;
	*j = last;
	/* pivot = v[(first + last) / 2]; */
	aux = 1.0 * (double)v[first] + (double)v[last] + (double)v[(first + last) / 2];
	pivot = (int)(aux / 3.0);

	/* pivot = (v[first] + v[last] + v[(first + last) / 2]) / 3; */
	while (*i <= *j) {
		while (v[*i] < pivot)
			(*i)++;
		while (pivot < v[*j])
			(*j)--;
		if (*i <= *j) {
			temp = v[*i];   /* intercambiar v[i] y v[j] */
			v[*i] = v[*j];
			v[*j] = temp;
			(*i)++;
			(*j)--;
		}
	}
}
/****************************************************************************/
/* Partition equilibrado (Brinch Hansen).
	Basndose en partition divide el array en dos mitades de modo que ambas
	tengan igual tamao. De este modo, la divisin de carga entre los
	procesadores ser equitativa.
	BIBLIOGRAFIA:   "Parallel Divide and Conquer" Per Brinch Hansen
						School of Computer and Information Science
						Syracuse University, Syracuse, New York, 13244, U.S.A.
						December 1991
*/
void find(int *v, int first, int last, int middle) {
  int left, right, i, j;

  left = first;
  right = last;
  while (left < right) {
    partition(v, &i, &j, left, right);
    if (middle <= j)
      right = j;
    else if (i <= middle)
      left = i;
    else left = right;
  }
}
/****************************************************************************/


